PUB Init(pv_DataStart)                                      
  Return ((pv_DataStart >> 2) << 18) + ((@__INIT >> 2) << 4)
                                                            
DAT                                                         
  ORG 0                                                     
__INIT                                                      
                mov         dira,__InitDirA                 
                mov         outa,__InitOutA                 


                                                             '' Define variables (LONGs only)
' reverbpc   var Long =50 '100   'parameter in percent       'reverbpc   var Long =50 '100   'parameter in percent

' feedbackpc var Long =50 '75   'parameter in percent          'feedbackpc var Long =50 '75     'parameter in percent



' time       VAR LONG                                        'time       VAR LONG

' offset     VAR LONG = 0                                    'offset     VAR LONG = 0

' sample     VAR LONG                                        'sample     VAR LONG

' lastSample VAR LONG = 0                                    'lastSample VAR LONG = 0

' temp       VAR LONG                                        'temp       VAR LONG


' sample1    VAR long                                        'sample1    VAR long

' sample2    VAR long =0                                     'sample2    VAR long =0

' wrpoint    VAR long =0                                     'wrpoint    VAR long =0

' rdpoint    VAR long =1                                     'rdpoint    VAR long =1

' samplen    VAR long = 0                                    'samplen    VAR long = 0



                                                             '' Define Subroutines
' ReadADC  FUNC 0                                            'ReadADC  FUNC 0

                                                             ''EchoSound FUNC 0
' PutRBuffer SUB 1                                           'PutRBuffer SUB 1

                                                             ''GetBuffer FUNC 0
' HallSound SUB 0                                            'HallSound SUB 0

' GetDistRBuffer FUNC 1                                      'GetDistRBuffer FUNC 1



                                                             '' Start of Task Code

                or          dira,LED1                        '  LOW LED1
                andn        outa,LED1                       

                or          dira,LEDs                        '  LOW Leds
                andn        outa,LEDs                       

                or          dira,MicOut                      '  LOW MICOUT
                andn        outa,MicOut                     

                or          dira,RightChan                   '  LOW RightChan
                andn        outa,RightChan                  

                or          dira,LeftChan                    '  LOW LeftCHAN
                andn        outa,LeftChan                   


                                                             '  ' Setup CNTA for ADC mode
                movi        ctra,#POSFB                      '  COUNTERA POSFB, MicFB, MicOut, 1, 0
                movs        ctra,#8                         
                movd        ctra,#9                         
                mov         frqa,#1                         
                mov         phsa,#0                         

                movi        ctrb,#56                         '  COUNTERB 56, 10, 11          ' Setup counter for DUTY-Differential output
                movs        ctrb,#10                        
                movd        ctrb,#11                        

                mov         time,cnt                         '  time = CNT + ADCVALUE
                adds        time,ADCVALUE                   


                                                             '  ' Allow ADC circuit to stabilize
                mov         temp,#1                          '  FOR temp = 1 TO 10000
__FOR_temp_4                                                

                call        #ReadADC                         '    sample = ReadADC
                mov         sample,__param1                 

                adds        temp,#1                          '  NEXT
                cmps        temp,_10000 WZ, WC              
    IF_BE       jmp         #__FOR_temp_4                   
__NEXT_temp_4                                               


                                                             '  ' Get sum of 64 samples to get an average offset value
                mov         temp,#1                          '  FOR temp = 1 TO 64
__FOR_temp_5                                                

                call        #ReadADC                         '    sample = ReadADC
                mov         sample,__param1                 

                                                             '    offset = offset + sample
                adds        offset,sample                   

                adds        temp,#1                          '  NEXT
                cmps        temp,#64 WZ, WC                 
    IF_BE       jmp         #__FOR_temp_5                   
__NEXT_temp_5                                               

                                                             '  offset = offset >> 6 ' Divide by 64 because we summed 64 samples
                shr         offset,#6                       


                                                             '  ' Get a sample and display on LEDs
__DO_10                                                      '  DO

                                                             '    ' You must make sure you get back here before the next sample is due
                or          dira,LED1                        '    High Led1 'Show Rest of Speed
                or          outa,LED1                       

                call        #ReadADC                         '    sample = ReadADC
                mov         sample,__param1                 

                or          dira,LED1                        '    Low led1
                andn        outa,LED1                       


                mov         sample1,sample                   '    sample1= sample

                                                             '    sample1 = sample1 - offset
                subs        sample1,offset                  

                                                             '    sample1 = sample1 max MaxAmpl
                maxs        sample1,MaxAmpl                 

                                                             '    sample1 = sample1 min MaxNegAmpl
                mins        sample1,MaxNegAmpl              

                mov         __temp1,__SSlot_ofs              '    wrlong sslot(0), sample1
                add         __temp1,par                     
                add         __temp1,#(0 * 4)                
                wrlong      sample1,__temp1                 

                adds        samplen,#1                       '    inc samplen

                mov         __temp1,__SampleNo_ofs           '    wrlong sampleno, samplen
                add         __temp1,par                     
                wrlong      samplen,__temp1                 


                                                             '    ' Subtract average offset from sample
                                                             '    sample = sample - offset
                subs        sample,offset                   


                                                             '    ' If sample is negative, then negate it (make it positve)
                abs         sample,sample                    '    sample = ABS sample


                                                             '    ' Only show 8 MSB of sample
                                                             '    sample = sample >> 5 'War 4
                shr         sample,#5                       


                                                             '    ' Show sample value on LEDs
                mov         __temp1,sample                   '    LEDs = sample
                rev         __temp1,#26                     
                shl         __temp1,#16                     
                andn        outa,LEDs                       
                or          outa,__temp1                    


                mov         __temp1,__SSlot_ofs              '    rdlong sslot(3), sample1
                add         __temp1,par                     
                add         __temp1,#(3 * 4)                
                rdlong      sample1,__temp1                 

                                                             '      'sample1= sample1 + AMPLITUDE
                                                             '      'sample1 = sample1 << 19    ' Convert 13-bit sample to 32-bit value
                                                             '      'FRQB = sample1            ' Output sample
                call        #HALLSOUND                       '    HALLSOUND


                jmp         #__DO_10                         'LOOP
__LOOP_10                                                   





                                                             '' Subroutine Code
HALLSOUND                                                    'SUB HALLSOUND ' Reverb


                mov         __temp1,sample2                  '      sample2 = sample2*feedbackpc
                mov         __temp2,feedbackpc              
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0044                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0044                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         sample2,__temp1                 

                mov         __temp1,sample2                  '      sample2 = sample2 / 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0045                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0045                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0046                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0046                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         sample2,__temp4                 

                                                             '      sample1 = sample1 + sample2
                adds        sample1,sample2                 

                mov         temp,sample1                     '      temp = sample1


                mov         __param1,sample1                 '      PutRBuffer sample1
                call        #PutRBuffer                     

                mov         __param1,#370                    '      sample1= GetDistRBuffer 370
                call        #GetDistRBuffer                 
                mov         sample1,__param1                

                mov         __param1,_970                    '      sample2= GetDistRBuffer 970
                call        #GetDistRBuffer                 
                mov         sample2,__param1                

                                                             '      sample1 = sample1 + sample2
                adds        sample1,sample2                 

                mov         __param1,_1500                   '      sample2= GetDistRBuffer 1500
                call        #GetDistRBuffer                 
                mov         sample2,__param1                

                                                             '      sample1 = sample1 + sample2
                adds        sample1,sample2                 

                mov         __param1,_2100                   '      sample2= GetDistRBuffer 2100
                call        #GetDistRBuffer                 
                mov         sample2,__param1                

                                                             '      sample1 = sample1 + sample2
                adds        sample1,sample2                 

                mov         __param1,_2450                   '      sample2= GetDistRBuffer 2450
                call        #GetDistRBuffer                 
                mov         sample2,__param1                

                                                             '      sample2 = sample1 + sample2
                adds        sample2,sample1                 

                mov         __temp1,sample2                  '      sample2 = sample2 / 5
                mov         __temp2,#5                      
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0047                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0047                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0048                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0048                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         sample2,__temp4                 

                mov         __temp1,sample2                  '      sample2 = sample2 * reverbpc
                mov         __temp2,reverbpc                
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0049                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0049                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         sample2,__temp1                 

                mov         __temp1,sample2                  '      sample2 = sample2 / 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0050                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0050                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0051                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0051                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         sample2,__temp4                 



                mov         sample1,temp                     '      sample1 = temp '/ 2


                                                             '      sample1 = sample1 + sample2
                adds        sample1,sample2                 


                                                             '      sample1 = sample1 max MaxAmpl
                maxs        sample1,MaxAmpl                 

                                                             '      sample1 = sample1 min MaxNegAmpl
                mins        sample1,MaxNegAmpl              

                                                             '      'wrlong sslot(7), sample1 
                                                             '      sample1= sample1 + AMPLITUDE
                adds        sample1,AMPLITUDE               

                                                             '      sample1 = sample1 << 19    ' Convert 13-bit sample to 32-bit value
                shl         sample1,#19                     

                mov         frqb,sample1                     '      FRQB = sample1            ' Output sample

HALLSOUND_ret                                                'ENDSUB
                ret                                         
                                                            




PutRBuffer                                                   'SUB PutRBuffer 'Writes into the reverb buffer

                mov         __temp1,__RBuf_ofs               '  wrword RBuf(wrpoint),__param1
                add         __temp1,par                     
                add         __temp1,wrpoint                 
                add         __temp1,wrpoint                 
                wrword      __param1,__temp1                

                adds        wrpoint,#1                       '  inc wrpoint

                cmps        wrpoint,RBUFLEN WZ, WC           '  if wrpoint = RBufLen then
    IF_NZ       jmp         #__ELSE_12                      

                mov         wrpoint,#0                       '    wrpoint= 0

__ELSE_12                                                    '  endif
__ENDIF_12                                                  

PutRBuffer_ret                                               'ENDSUB
                ret                                         
                                                            


GetDistRBuffer                                               'FUNC GetDistRBuffer 'Reads from reverb buffer

                mov         rdpoint,wrpoint                  '  rdpoint = wrpoint - __param1
                subs        rdpoint,__param1                

                cmps        rdpoint,#0 WZ, WC                '  if rdpoint < 0 then
    IF_AE       jmp         #__ELSE_13                      

                                                             '    rdpoint= rdpoint + RBufLen
                adds        rdpoint,RBUFLEN                 

__ELSE_13                                                    '  endif
__ENDIF_13                                                  

                mov         __temp1,__RBuf_ofs               '  rdword RBuf(rdpoint),__param1
                add         __temp1,par                     
                add         __temp1,rdpoint                 
                add         __temp1,rdpoint                 
                rdword      __param1,__temp1                

   shl     __param1, #16 ' restore the sign                  '  \ shl     __param1, #16 ' restore the sign

   sar     __param1, #16                                     '  \ sar     __param1, #16

GetDistRBuffer_ret                                           '  return __param1
                ret                                         

                                                             'ENDFUNC




ReadADC                                                      'FUNC ReadADC


                waitcnt     time,ADCVALUE                    '  WAITCNT time, ADCVALUE

                mov         __param1,phsa                    '  __PARAM1 = PHSA - lastSample
                subs        __param1,lastSample             

                                                             '  lastSample = lastSample + __PARAM1
                adds        lastSample,__param1             

ReadADC_ret                                                  '  RETURN __PARAM1
                ret                                         

                                                             'ENDFUNC


                mov         __temp1,#0                       'ENDTASK
                waitpne     __temp1,__temp1                 
'**********************************************************************
__InitDirA       LONG %00000000_00000000_00000000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
MaxNegAmpl       LONG -4000
MicFB            LONG 1 << 8
MicOut           LONG 1 << 9
_970             LONG 970
RightChan        LONG 1 << 10
_1500            LONG 1500
LeftChan         LONG 1 << 11
_2100            LONG 2100
_2450            LONG 2450
RBUFLEN          LONG 2_500
MaxAmpl          LONG 4000
AMPLITUDE        LONG 4096
ADCVALUE         LONG 8192
_10000           LONG 10_000
__RBuf_ofs       LONG RBuf_ofs
__SSlot_ofs      LONG SSlot_ofs
__SampleNo_ofs   LONG SampleNo_ofs
LEDs             LONG 63 << 16
LED1             LONG 1 << 23

reverbpc         LONG 50
feedbackpc       LONG 50
offset           LONG 0
lastSample       LONG 0
sample2          LONG 0
wrpoint          LONG 0
rdpoint          LONG 1
samplen          LONG 0

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
__param1         RES 1
__param2         RES 1
__param3         RES 1
__param4         RES 1
__paramcnt       RES 1
time             RES 1
sample           RES 1
temp             RES 1
sample1          RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  POSFB                            = 72
  SinLen                           = 35
  ConSt2                           = 2
  EBuf_ofs                         = 0
  RBuf_ofs                         = 14000
  SSlot_ofs                        = 19000
  SampleNo_ofs                     = 19016
  debug_ofs                        = 19020
  SINTAB_ofs                       = 19024
  ADDAC_Reverb_COG_ofs             = 19096
  Gen_Sinus_COG_ofs                = 19100
  Distortion_COG_ofs               = 19104
  Compressor_COG_ofs               = 19108
  Echo_COG_ofs                     = 19112