PUB Init(pv_DataStart)                                      
  Return ((pv_DataStart >> 2) << 18) + ((@__INIT >> 2) << 4)
                                                            
DAT                                                         
  ORG 0                                                     
__INIT                                                      
                mov         dira,__InitDirA                 
                mov         outa,__InitOutA                 

                                                             '' Works with two amplification factors
                                                             '' First works to the input limit, second starting there to maximum.

                                                             '' Define variables (LONGs only)
' LimitIn1Pc var long = 99'85  'percentage of Amplitude to be magnified to 'LimitIn1Pc var long = 99'85  'percentage of Amplitude to be magnified to

' Limit1Pc   var long = 99 '70 '99                           'Limit1Pc   var long = 99 '70 '99

' Limit2Pc   var long = 101 '115 '>=101 100% Input will be magnified to x%, but it is then truncated to 100%  'Limit2Pc   var long = 101 '115 '>=101 100% Input will be magnified to x%, but it is then truncated to 100% 


' V0 VAR long                                                'V0 VAR long

' V1 Var long                                                'V1 Var long

' b1 VAR long                                                'b1 VAR long

' Limit1 VAR long                                            'Limit1 VAR long

' Limit2 Var long                                            'Limit2 Var long

' last_sampl var long =0                                     'last_sampl var long =0

' i  VAR long                                                'i  VAR long

' temp       var long                                        'temp       var long 

' temp2       var long                                       'temp2       var long 



                                                             '' Define Subroutines
' WaitSample SUB                                             'WaitSample SUB

' CalcV SUB                                                  'CalcV SUB

' Distort Func 1                                             'Distort Func 1


                                                             '' Start of Task Code
                mov         __paramcnt,#0                    '  CalcV
                call        #CalcV                          

__DO_6                                                       '  do

                mov         __paramcnt,#0                    '     WaitSample
                call        #WaitSample                     

                mov         __temp1,__SSlot_ofs              '     rdlong sslot(1),i
                add         __temp1,par                     
                add         __temp1,#(1 * 4)                
                rdlong      i,__temp1                       

                mov         __param1,i                       '     temp= Distort i
                call        #Distort                        
                mov         temp,__param1                   

                mov         __temp1,__SSlot_ofs              '     wrlong sslot(2),temp
                add         __temp1,par                     
                add         __temp1,#(2 * 4)                
                wrlong      temp,__temp1                    

                jmp         #__DO_6                          '  loop
__LOOP_6                                                    



                                                             '' Subroutine Code

Distort                                                      'Func Distort

                                                             '   '__param1 = -3500
                abs         temp,__param1                    '   temp = abs __param1

                cmps        temp,Limit1 WZ, WC               '   if temp < Limit1 then
    IF_AE       jmp         #__ELSE_7                       

                mov         __temp1,__param1                 '      temp2 = __param1 * V0
                mov         __temp2,V0                      
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0023                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0023                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         temp2,__temp1                   

                mov         __temp1,temp2                    '      temp2 = temp2 / 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0024                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0024                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0025                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0025                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         temp2,__temp4                   

                jmp         #__ENDIF_7                       '   elseif temp < MaxAmpl then
__ELSE_7                                                    
                cmps        temp,MaxAmpl WZ, WC             
    IF_AE       jmp         #__ELSE_8                       

                cmps        __param1,#0 WZ, WC               '      if __param1>0 then
    IF_BE       jmp         #__ELSE_9                       

                mov         temp2,__param1                   '        temp2 = __param1 - Limit1
                subs        temp2,Limit1                    

                mov         __temp1,temp2                    '        temp2 = temp2 * V1
                mov         __temp2,V1                      
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0026                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0026                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         temp2,__temp1                   

                mov         __temp1,temp2                    '        temp2 = temp2 / 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0027                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0027                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0028                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0028                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         temp2,__temp4                   

                                                             '        temp2 = temp2 + Limit2
                adds        temp2,Limit2                    

                jmp         #__ENDIF_9                       '      else
__ELSE_9                                                    

                mov         temp2,__param1                   '        temp2 = __param1 + Limit1
                adds        temp2,Limit1                    

                mov         __temp1,temp2                    '        temp2 = temp2 * V1
                mov         __temp2,V1                      
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0029                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0029                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         temp2,__temp1                   

                mov         __temp1,temp2                    '        temp2 = temp2 / 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0030                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0030                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0031                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0031                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         temp2,__temp4                   

                                                             '        temp2 = temp2 - Limit2
                subs        temp2,Limit2                    

__ENDIF_9                                                    '      endif

                jmp         #__ENDIF_7                       '   else
__ELSE_8                                                    

                mov         temp2,__param1                   '      temp2 = __param1

__ENDIF_7                                                    '   endif

                mov         __param1,temp2                   '   __param1 = temp2

                                                             '   __param1 = __param1 max MaxAmpl
                maxs        __param1,MaxAmpl                

                                                             '   __param1 = __param1 min MaxNegAmpl   
                mins        __param1,MaxNegAmpl             


                                                             '   'wrlong debug, __param1
Distort_ret                                                  '   return __param1
                ret                                         

                                                             'endfunc



CalcV                                                        'sub CalcV 'Calculate Amplification Faktors

                mov         __temp1,Limit1Pc                 '   temp = 100 * Limit1Pc
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0032                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0032                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         temp,__temp1                    


                mov         __temp1,temp                     '   V0 = temp / LimitIn1Pc
                mov         __temp2,LimitIn1Pc              
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0033                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0033                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0034                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0034                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         V0,__temp4                      


                mov         temp,Limit2Pc                    '   temp = Limit2Pc - Limit1Pc
                subs        temp,Limit1Pc                   

                mov         __temp1,temp                     '   temp = temp * 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0035                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0035                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         temp,__temp1                    

                mov         temp2,#101                       '   temp2 = 101 - LimitIn1Pc
                subs        temp2,LimitIn1Pc                

                mov         __temp1,temp                     '   V1 = temp / temp2
                mov         __temp2,temp2                   
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0036                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0036                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0037                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0037                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         V1,__temp4                      


                mov         __temp1,Limit1Pc                 '   Limit2 = Limit1Pc * MaxAmpl
                mov         __temp2,MaxAmpl                 
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0038                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0038                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         Limit2,__temp1                  

                mov         __temp1,Limit2                   '   Limit2 = Limit2 / 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0039                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0039                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0040                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0040                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         Limit2,__temp4                  


                mov         __temp1,LimitIn1Pc               '   Limit1 = LimitIn1Pc * MaxAmpl
                mov         __temp2,MaxAmpl                 
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0041                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0041                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         Limit1,__temp1                  

                mov         __temp1,Limit1                   '   Limit1 = Limit1 / 100
                mov         __temp2,#100                    
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0042                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0042                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0043                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0043                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         Limit1,__temp4                  

CalcV_ret                                                    'endsub
                ret                                         
                                                            






                                                             '' Subroutine Code
WaitSample                                                   'sub WaitSample

__DO_7                                                       '  do

                mov         __temp1,__SampleNo_ofs           '    rdlong SampleNo , temp
                add         __temp1,par                     
                rdlong      temp,__temp1                    

                cmps        temp,last_sampl WZ, WC           '  loop until temp <> last_sampl
    IF_Z        jmp         #__DO_7                         

                mov         last_sampl,temp                  '  last_sampl= temp

WaitSample_ret                                               'endsub
                ret                                         
                                                            

                mov         __temp1,#0                       'ENDTASK
                waitpne     __temp1,__temp1                 
'**********************************************************************
__InitDirA       LONG %00000000_00000000_00000000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
MaxNegAmpl       LONG -4000
MaxAmpl          LONG 4000
__SSlot_ofs      LONG SSlot_ofs
__SampleNo_ofs   LONG SampleNo_ofs

LimitIn1Pc       LONG 99
Limit1Pc         LONG 99
Limit2Pc         LONG 101
last_sampl       LONG 0

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
__param1         RES 1
__param2         RES 1
__param3         RES 1
__param4         RES 1
__paramcnt       RES 1
V0               RES 1
V1               RES 1
b1               RES 1
Limit1           RES 1
Limit2           RES 1
i                RES 1
temp             RES 1
temp2            RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  POSFB                            = 72
  SinLen                           = 35
  ConSt2                           = 2
  EBuf_ofs                         = 0
  RBuf_ofs                         = 14000
  SSlot_ofs                        = 19000
  SampleNo_ofs                     = 19016
  debug_ofs                        = 19020
  SINTAB_ofs                       = 19024
  ADDAC_Reverb_COG_ofs             = 19096
  Gen_Sinus_COG_ofs                = 19100
  Distortion_COG_ofs               = 19104
  Compressor_COG_ofs               = 19108
  Echo_COG_ofs                     = 19112